<?php
Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "insurance_company".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "InsuranceCompany".
 *
 * Columns in table "insurance_company" available as properties of the model,
 * followed by relations of table "insurance_company" available as properties of the model.
 *
 * @property integer $id
 * @property integer $localization_id
 * @property string $name
 * @property string $internal_name
 * @property string $friendly_url
 * @property integer $visits_number
 * @property integer $priority
 * @property string $friendly_url_redirected
 * @property string $url_submitted
 * @property string $url_providers
 * @property string $url_plans
 *
 * @property Insurance[] $insurances
 * @property Localization $localization
 * @property InsuranceCompanyAlias[] $insuranceCompanyAliases
 * @property SchedulingMail[] $schedulingMails
 */
abstract class BaseInsuranceCompany extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'insurance_company';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'InsuranceCompany|InsuranceCompanies', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array(
                'name, internal_name',
                'required'
            ),
            array(
                'localization_id, visits_number, priority',
                'numerical',
                'integerOnly' => true
            ),
            array(
                'name',
                'length',
                'max' => 60
            ),
            array(
                'internal_name',
                'length',
                'max' => 100
            ),
            array(
                'friendly_url, friendly_url_redirected, url_submitted',
                'length',
                'max' => 255
            ),
            array(
                'url_providers, url_plans',
                'safe'
            ),
            array(
                'localization_id, friendly_url, visits_number, priority, friendly_url_redirected, url_submitted, url_providers, url_plans',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, localization_id, name, internal_name, friendly_url, visits_number, priority, friendly_url_redirected, url_submitted, url_providers, url_plans',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array(
            'insurances' => array(
                self::HAS_MANY,
                'Insurance',
                'company_id'
            ),
            'localization' => array(
                self::BELONGS_TO,
                'Localization',
                'localization_id'
            ),
            'insuranceCompanyAliases' => array(
                self::HAS_MANY,
                'InsuranceCompanyAlias',
                'company_id'
            ),
            'schedulingMails' => array(
                self::HAS_MANY,
                'SchedulingMail',
                'insurance_company_id'
            )
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => null,
            'name' => Yii::t('app', 'Name'),
            'internal_name' => Yii::t('app', 'Internal Name'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'visits_number' => Yii::t('app', 'Visits Number'),
            'priority' => Yii::t('app', 'Priority'),
            'friendly_url_redirected' => Yii::t('app', 'Friendly Url Redirected'),
            'url_submitted' => Yii::t('app', 'Url Submitted'),
            'url_providers' => Yii::t('app', 'Url Providers'),
            'url_plans' => Yii::t('app', 'Url Plans'),
            'insurances' => null,
            'localization' => null,
            'insuranceCompanyAliases' => null,
            'schedulingMails' => null
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('internal_name', $this->internal_name, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('visits_number', $this->visits_number);
        $criteria->compare('priority', $this->priority);
        $criteria->compare('friendly_url_redirected', $this->friendly_url_redirected, true);
        $criteria->compare('url_submitted', $this->url_submitted, true);
        $criteria->compare('url_providers', $this->url_providers, true);
        $criteria->compare('url_plans', $this->url_plans, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria
        ));
    }
}
